<?php
/*
=====================================================
 Name: DLE-Billing integration from Enot.io
 Author: Roman Borkunov
 Telegram: @broqit
=====================================================
*/

if( !defined( 'BILLING_MODULE' ) ) {
	die( "Hacking attempt!" );
}

Class Payment {
	var $doc = "https://enot.io/en/knowledge/index";
	var $server = 0;

	function Settings( $config ) 
	{
		$Form = [];
	
		$Form[] = [
			"Идентификатор магазина:", 
			"Ваш идентификатор в системе Enot. (Например, 2311)",
			"<input name=\"save_con[id]\" class=\"form-control\" type=\"text\" value=\"" . $config['id'] ."\">"
		];
		$Form[] = [
			"Пароль #1:", 
			"Используется интерфейсом инициализации оплаты.", 
			"<input name=\"save_con[pass1]\" class=\"form-control\" type=\"text\" value=\"" . $config['pass1'] ."\">"
		];
		$Form[] = [
			"Пароль #2:", 
			"Используется интерфейсом оповещения о платеже, XML-интерфейсах.", 
			"<input name=\"save_con[pass2]\" class=\"form-control\" type=\"text\" value=\"" . $config['pass2'] ."\">"
		];
        $Form[] = [
            "Валюта платежа:",
            "Выберите валюту совершения платежа.",
            "<select name=\"save_con[currency]\" class=\"uniform\">
				<option value=\"RUB\" " . ( $config['currency'] == 'RUB' ? "selected" : "" ) . ">RUB</option>
				<option value=\"USD\" " . ( $config['currency'] == 'USD' ? "selected" : "" ) . ">USD</option>
				<option value=\"EUR\" " . ( $config['currency'] == 'EUR' ? "selected" : "" ) . ">EUR</option>
				<option value=\"UAH\" " . ( $config['currency'] == 'UAH' ? "selected" : "" ) . ">UAH</option>
			</select>"
        ];

		return $Form;
	}

	private function generateSign($params, $separator = ':')
	{
		$signature = implode(':', $params);

		return md5($signature);
	}

	function Form( $id, $config_payment, $invoice, $currency, $desc )
	{
	    global $config;

        $billing_config = require MODULE_DATA . '/config.php';

		$generateSign = $this->generateSign([
            $config_payment['id'],
            $invoice['invoice_pay'],
            $config_payment['pass1'],
			$id
		]);

        $success_url = $config['http_home_url'] . 'billing.html/pay/ok';
        $fail_url = $config['http_home_url'] . 'billing.html/pay/bad';

        if( !$desc ) {
            $desc = 'Пополнение баланса пользователем ' . $invoice['invoice_user_name'].' на сумму ' . $invoice['invoice_get'] . ' ' . $currency;
        }

        return '<form method="get" id="paysys_form" action="https://enot.io/_/pay">
				<input type=hidden name=m value="' . $config_payment['id'] . '">
				<input type=hidden name=oa value="' . $invoice['invoice_pay'] . '">
				<input type=hidden name=o value="' . $id . '">
				<input type=hidden name=s value="' . $generateSign . '">
				<input type=hidden name=cr value="' . $config_payment['currency'] . '">
				<input type=hidden name=c value="' . $desc . '">
				<input type=hidden name=success_url value="' . $success_url . '">
				<input type=hidden name=fail_url value="' . $fail_url . '">
				
				<input type="submit" name="process" class="bs_button" value="Оплатить" />
			</form>';
	}
	
	function check_id( $result ) 
	{
		return $result['merchant_id'];
	}
	
	function check_ok( $result ) 
	{
		return 'OK' . $result['merchant_id'];
	}
	
	function check_out( $result, $config, $invoice ) 
	{
        $generateSign = $this->generateSign([
            $config['id'],
            $result['amount'],
            $config['pass2'],
            $result['merchant_id']
        ]);

		if (!hash_equals(strtoupper($generateSign), strtoupper($result['sign_2']))) {
			return "Verifying the signature information about the payment failed!\n";
		}

		return 200;
	}
}

$Paysys = new Payment;